> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve an invoice write-off async job

GET https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/{asyncJobId}

Retrieves information about a specific asynchronous\ \ invoice write-off job.\n\n**Note:** This operation is only available if you have \<a href="[https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/get-started-with-invoice-settlement/invoice-settlement-overview](https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/get-started-with-invoice-settlement/invoice-settlement-overview)" target=“\_blank”>Invoice Settlement\</a>\ \ enabled. The Invoice Settlement feature is generally available as of Zuora Billing\ \ Release 296 (March 2021). This feature includes Unapplied Payments, Credit and\ \ Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement,\ \ see  \<a href="[https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/invoice-settlement-migration-checklist-and-guide](https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/invoice-settlement-migration-checklist-and-guide)" target=“\_blank”>Invoice Settlement Enablement and Checklist Guide\</a>\ \ for more information.\n

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoices/retrieve-invoice-write-off-async-job

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `asyncJobId` (string, required) — The unique ID of the invoice write-off async job. For example, 8a92ade496140e830196141f6cfa0001.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Authorization` (string, optional) — The value is in the `Bearer {token}` format where \{token} is a valid OAuth token generated by calling [Create an OAuth token](https://developer.zuora.com/api-references/api/operation/createToken).
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of WriteOffInvoiceAsyncJobResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `id` (string, optional) — The ID of the operation job.
- `status` (enum, optional) — Job status of the Invoice Settlement async job.
  - Allowed values: `Pending`, `Processing`, `Processed`, `Error`
- `operationType` (enum, optional) — Operation type of the Invoice Settlement async job.
  - Allowed values: `AsyncCreditMemoApply`, `AsyncCreditMemoUnapply`
- `referenceId` (string, optional) — The ID of the business object which is being operated.
- `referenceType` (enum, optional) — Reference type of the Invoice Settlement async job.
  - Allowed values: `CreditMemo`
- `error` (string, optional, nullable) — The error message if the operation fails.
- `creditMemo` (WriteOffInvoiceResponseCreditMemo, optional) — Container for the credit memo that is automatically generated when writing off invoices.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Unauthorized

- `code` (integer, optional) — The error code.
- `message` (string, optional) — The error message.

## Types

### WriteOffInvoiceAsyncJobResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### WriteOffInvoiceResponseCreditMemo

Container for the credit memo that is automatically generated when writing off invoices.

- `id` (string, optional) — The ID of the credit memo that is created when the invoice is written off.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "success": true,
  "id": "40288ae9600808280160081dc9c13f15",
  "status": "Processed",
  "operationType": "AsyncCreditMemoApply",
  "referenceId": "4028905f5a890526015a8d73f73d0015",
  "referenceType": "CreditMemo",
  "error": null,
  "creditMemo": {
    "id": "402890555a40ca7f015a5b099b0e307a"
  }
}
```

**SDK Code**

```python Invoices_retrieveInvoiceWriteOffAsyncJob_example
import requests

url = "https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Invoices_retrieveInvoiceWriteOffAsyncJob_example
const url = 'https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Invoices_retrieveInvoiceWriteOffAsyncJob_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Invoices_retrieveInvoiceWriteOffAsyncJob_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Invoices_retrieveInvoiceWriteOffAsyncJob_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Invoices_retrieveInvoiceWriteOffAsyncJob_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Invoices_retrieveInvoiceWriteOffAsyncJob_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Invoices_retrieveInvoiceWriteOffAsyncJob_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoices/write-off-async-jobs/asyncJobId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```